%define anolis_release 1
%global _lto_cflags %{nil}

Name:           gnutls
Version:        3.7.7
Release:        %{anolis_release}%{?dist}
Summary:        A TLS protocol implementation 

License:        GPLv3+ and LGPLv2+ 
URL:            http://www.gnutls.org/ 
Source0:        https://www.gnupg.org/ftp/gcrypt/gnutls/v3.7/%{name}-%{version}.tar.xz

Patch1: gnutls-3.6.7-no-now-guile.patch
Patch2: gnutls-3.2.7-rpath.patch
Patch3: gnutls-3.7.7-KTLS-hotfix.patch

BuildRequires:  p11-kit-devel gettext-devel zlib-devel readline-devel libtasn1-devel nettle-devel tpm2-tss-devel libidn2-devel libunistring-devel 
BuildRequires:  make automake autoconf gperf libtool texinfo net-tools datefudge softhsm gcc gcc-c++ gnupg2 fipscheck p11-kit-trust ca-certificates gtk-doc
BuildRequires:  unbound-devel unbound-libs 
Requires:       crypto-policies p11-kit-trust libtasn1 nettle 

Provides: bundled(gnulib) = 20130424

%package c++
Summary: The C++ interface to GnuTLS
Requires: %{name} = %{version}-%{release}

%package devel
Summary: Development files for the %{name} package
Requires: %{name} = %{version}-%{release}
Requires: %{name}-c++ = %{version}-%{release}
Requires: %{name}-dane = %{version}-%{release}
Requires: pkgconfig

%package utils
License: GPLv3+
Summary: Command line tools for TLS protocol
Requires: %{name} = %{version}-%{release}
Requires: %{name}-dane = %{version}-%{release}

%package dane
Summary: A DANE protocol implementation for GnuTLS
Requires: %{name} = %{version}-%{release}

%package doc
Summary: Doc files for GnuTLS
Requires: %{name} = %{version}-%{release}
BuildArch: noarch


%description
GnuTLS is a secure communications library implementing the SSL, TLS and DTLS
protocols and technologies around them. It provides a simple C language
application programming interface (API) to access the secure communications
protocols as well as APIs to parse and write X.509, PKCS #12, OpenPGP and
other required structures.

%description c++
GnuTLS is a secure communications library implementing the SSL, TLS and DTLS
protocols and technologies around them. It provides a simple C language
application programming interface (API) to access the secure communications
protocols as well as APIs to parse and write X.509, PKCS #12, OpenPGP and
other required structures.

%description devel
GnuTLS is a secure communications library implementing the SSL, TLS and DTLS
protocols and technologies around them. It provides a simple C language
application programming interface (API) to access the secure communications
protocols as well as APIs to parse and write X.509, PKCS #12, OpenPGP and
other required structures.
This package contains files needed for developing applications with
the GnuTLS library.

%description utils
GnuTLS is a secure communications library implementing the SSL, TLS and DTLS
protocols and technologies around them. It provides a simple C language
application programming interface (API) to access the secure communications
protocols as well as APIs to parse and write X.509, PKCS #12, OpenPGP and
other required structures.
This package contains command line TLS client and server and certificate
manipulation tools.

%description dane
GnuTLS is a secure communications library implementing the SSL, TLS and DTLS
protocols and technologies around them. It provides a simple C language
application programming interface (API) to access the secure communications
protocols as well as APIs to parse and write X.509, PKCS #12, OpenPGP and
other required structures.
This package contains library that implements the DANE protocol for verifying
TLS certificates through DNSSEC.

%description doc
Doc files for GnuTLS

%prep
%autosetup -p1
rm -f src/libopts/*.c src/libopts/*.h src/libopts/compat/*.c src/libopts/compat/*.h
autoreconf -fi

sed -i -e 's|sys_lib_dlsearch_path_spec="/lib /usr/lib|sys_lib_dlsearch_path_spec="/lib /usr/lib %{_libdir}|g' configure
rm -f lib/minitasn1/*.c lib/minitasn1/*.h

echo "SYSTEM=NORMAL" >> tests/system.prio

%build
eval $(sed -n 's/^\(\(NAME\|VERSION_ID\)=.*\)/OS_\1/p' /etc/os-release)
export FIPS_MODULE_NAME="$OS_NAME $OS_VERSION_ID %name"

%configure \
           --enable-fips140-mode \
           --with-fips140-module-name="$FIPS_MODULE_NAME" \
           --with-fips140-module-version=%{version}-%{srpmhash} \
           --disable-gost \
           --enable-sha1-support \
           --disable-static \
           --disable-openssl-compatibility \
           --disable-non-suiteb-curves \
           --with-system-priority-file=%{_sysconfdir}/crypto-policies/back-ends/gnutls.config \
           --with-default-trust-store-pkcs11="pkcs11:" \
           --without-tpm \
           --with-tpm2 \
           --htmldir=%{_docdir}/manual \
           --disable-guile \
           --with-unbound-root-key-file=/var/lib/unbound/root.key \
           --enable-libdane \
           --disable-rpath \
           --with-default-priority-string="@SYSTEM"

%make_build V=1

%define __spec_install_post \
        %{?__debug_package:%{__debug_install_post}} \
        %{__arch_install_post} \
        %{__os_install_post} \
        rm -f $RPM_BUILD_ROOT%{_libdir}/.libgnutls.so.*.hmac \
        fipshmac -d $RPM_BUILD_ROOT%{_libdir} $RPM_BUILD_ROOT%{_libdir}/libgnutls.so.30.*.* \
        file=`basename $RPM_BUILD_ROOT%{_libdir}/libgnutls.so.30.*.hmac` && mv $RPM_BUILD_ROOT%{_libdir}/$file $RPM_BUILD_ROOT%{_libdir}/.$file && ln -s .$file $RPM_BUILD_ROOT%{_libdir}/.libgnutls.so.30.hmac \
%{nil}


%install
rm -rf $RPM_BUILD_ROOT
%make_install
make -C doc install-html DESTDIR=$RPM_BUILD_ROOT
rm -f $RPM_BUILD_ROOT%{_infodir}/dir
rm -f $RPM_BUILD_ROOT%{_libdir}/*.la
rm -f $RPM_BUILD_ROOT%{_libdir}/guile/2.2/guile-gnutls*.{a,la}
rm -f $RPM_BUILD_ROOT%{_libdir}/pkgconfig/gnutls-dane.pc

%find_lang gnutls

%check
make check %{?_smp_mflags} GNUTLS_SYSTEM_PRIORITY_FILE=/dev/null

%files -f gnutls.lang
%{_libdir}/libgnutls.so.30*
%{_libdir}/.libgnutls.so.30*.hmac
%license LICENSE doc/COPYING doc/COPYING.LESSER

%files c++
%{_libdir}/libgnutlsxx.so.*

%files devel
%{_includedir}/*
%{_libdir}/libgnutls*.so
%{_libdir}/.libgnutls.so.*.hmac

%{_libdir}/pkgconfig/*.pc
%{_mandir}/man3/*
%{_infodir}/gnutls*
%{_infodir}/pkcs11-vision*
%{_docdir}/manual/*

%files utils
%{_bindir}/*
%{_mandir}/man1/*
%doc doc/certtool.cfg

%files dane
%{_libdir}/libgnutls-dane.so.*

%files doc
%doc README.md AUTHORS NEWS THANKS

%changelog
* Tue Aug 30 2022 Chunmei Xu <xuchunmei@linux.alibaba.com> - 3.7.7-1
- update to 3.7.7

* Thu Mar 10 2022 forrest_ly <flin@linux.alibaba.com> - 3.7.3-1
- Init for Anolis OS 23
